﻿using Client.ServiceReference1;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.ServiceModel;
using System.ServiceModel.Discovery;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Client
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        protected ChatClient client;
        private void button1_Click(object sender, EventArgs e)
        {
            UdpDiscoveryEndpoint endp = new UdpDiscoveryEndpoint();
            DiscoveryClient c = new DiscoveryClient(endp);
            FindCriteria fc = new FindCriteria(typeof(Chat));
            fc.Duration = new TimeSpan(0, 0, 1);
            FindResponse res = c.Find(fc);
            string url = res.Endpoints[0].Address.ToString();
            NetTcpBinding bind = new NetTcpBinding();
            bind.Security.Mode = SecurityMode.None;
            client = new ChatClient(bind, new EndpointAddress(url));
            client.Open();
            butConnect.Enabled = false;
            butDisconnect.Enabled = true;
        }

        private void butDisconnect_Click(object sender, EventArgs e)
        {
            if (client.State == CommunicationState.Opened)
               client.Close();
            butConnect.Enabled = true;
            butDisconnect.Enabled = false;
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            client.BeginSleep(10, delegate(IAsyncResult ir)
            {
                double res = ((ChatClient)(ir.AsyncState)).EndSleep(ir);
                textBox2.Invoke(new Action(delegate()
                {
                    textBox2.Text = res.ToString();
                }));
                
            }, client);
            //textBox2.Text = client.Sleep(10).ToString();
        }
    }
}
